<?php

namespace Uncanny_Automator_Pro;

/**
 * Class Uncanny_Automator_Pro\Metabox_Tokens_Pro
 *
 * @since 4.3.0
 * @package Uncanny_Automator_Pro\Metabox_Tokens_Pro
 */
class Metabox_Tokens_Pro {


	/**
	 * The common tokens. A callback method in each trigger via $this->set_tokens()
	 *
	 * @return array[] The list of tokens where array key is the token identifier.
	 */
	public function common_tokens() {

		return array(
			'FIELD_NAME'  => array(
				'name'         => __( 'Field name', 'uncanny-automator-pro' ),
				'hydrate_with' => 'trigger_args|2',
			),
			'FIELD_VALUE' => array(
				'name'         => __( 'Field value', 'uncanny-automator-pro' ),
				'hydrate_with' => 'trigger_args|3',
			),
		);

	}

	/**
	 * Populate the token with actual values.
	 *
	 * @param $args
	 * @param $trigger
	 *
	 * @return array
	 */
	public function hydrate_tokens( $parsed, $args, $trigger ) {

		$post_id = $args['trigger_args'][1];

		return $parsed + array(
			'POST_TYPE'           => get_the_title( $post_id ),
			'POST_TYPE_ID'        => absint( $post_id ),
			'POST_TYPE_URL'       => get_permalink( $post_id ),
			'POST_TYPE_THUMB_ID'  => get_post_thumbnail_id( $post_id ),
			'POST_TYPE_THUMB_URL' => get_the_post_thumbnail_url( $post_id ),
		);

	}

}
